<template>
  <div class="container mx-auto">
    <div class="flex py-6">
      <h2 class="text-xl">
        Product Health Kit
      </h2>
      <div class="ml-auto">
        <nuxt-link to="/products">
          <span class="px-6 text-black bg-ui-100">Lihat semua barang</span>
        </nuxt-link>
      </div>
    </div>
    <div>

      <div v-if="is_loading">Memuat produk...</div>

      <div v-else>

        <alert-error v-if="error">
          {{ error.message }}
        </alert-error>

        <div v-else class="grid grid-cols-4 gap-6 pb-12">

          <nuxt-link
            v-for="product in items"
            :key="product.id"
            :to="`products/${product.id}`"
          >
            <product-card>
              <img
                :src="product.image"
                :title="product.name"
                :alt="product.name"
                class="w-full"
                slot="header"
              />

              <div class="pt-6 p-3 text-left">
                <div class="italic">
                  {{ product.name }}
                </div>
                <div>
                  {{ product.price | currencyFormat }}
                </div>
                <div class="text-data-blue uppercase">
                  {{ product.producer }}
                </div>
              </div>
            </product-card>
          </nuxt-link>

        </div>

      </div>


    </div>
  </div>
</template>

<script>
import { mapGetters, mapState } from 'vuex';

import currencyFormat from '~/mixins/filters/currencyFormat';

import AlertError from '~/components/alerts/error.vue';
import ProductCard from '~/components/ProductCard.vue';

export default {
  async asyncData(
    { isDev, route, store, env, params, query, req, res, redirect, error },
  ) {
    if (!store.state.products.rawData) {
      await store.dispatch('products/fetchAll');
    }
  },

  components: {
    AlertError,
    ProductCard,
  },

  mixins: [
    currencyFormat,
  ],

  computed: {
    ...mapGetters({
      items: 'products/items',
    }),
    ...mapState({
      error: state => state.products.error,
      is_loading: state => state.products.is_loading,
    }),
  },
};
</script>

<style>

</style>
